//=============================================================================
// GunlocScout.
//=============================================================================
class GunlocScout expands Scout;

var() float Radiuses[5];
var() float Heights[5];

event PreBeginPlay()
{
	bHidden = True;
	bCanJump = True;
	bCanWalk = True;
	bCanSwim = True;
	bCanFly = False;
	bCanOpenDoors = True;
	bCanDoSpecial = True;
	LifeSpan = 0.1;
}

event PostBeginPlay()
{
}

event Destroyed()
{
}

function bool CheckReachability( NavigationPoint Start, NavigationPoint End)
{
	local int ShrinkIdx;

	Shrink(ShrinkIdx);
	bCollideWorld = true;
	bCollideWhenPlacing = true;
	while ( !SetLocation(Start.Location) )
		if ( !Shrink(ShrinkIdx) )
			return false;
	Move( vect(0,0,-1) * CollisionHeight);
	
	if ( Region.Zone.bWaterZone )	SetPhysics( PHYS_Swimming);
	else							SetPhysics( PHYS_Walking);

	while ( !PointReachable(End.Location) )
		if ( !Shrink(ShrinkIdx) )
			return false;
	return true;
}

event FellOutOfWorld()
{
}

function bool Shrink( out int ShrinkInto)
{
	if ( ShrinkInto >= ArrayCount(Radiuses) )
		return false;
	SetCollisionSize( Radiuses[ShrinkInto], Heights[ShrinkInto]);
	ShrinkInto++;
	return true;
}

defaultproperties
{
	Radiuses(0)=50.000000
	Radiuses(1)=42.000000
	Radiuses(2)=30.000000
	Radiuses(3)=18.000000
	Radiuses(4)=4.000000
	Heights(0)=70.000000
	Heights(1)=65.000000
	Heights(2)=52.000000
	Heights(3)=48.000000
	Heights(4)=39.000000
	GroundSpeed=400.000000
	WaterSpeed=280.000000
	AirSpeed=400.000000
	JumpZ=325.000000
	UnderWaterTime=20.000000
	CollisionRadius=4.000000
	CollisionHeight=48.000000
	bGameRelevant=True
}
