//=============================================================================
// NoLost.
//=============================================================================
class NoLost expands Actor;

var() float Interval;
var() int RangeRun;
var bool bGoodSet, bReady;

event PostBeginPlay()
{
	if ( Interval > 1.00 )
		bGoodSet=True;
	bHidden=True;
}

function CheckLost()
{
	local Bot aBotyMan;
	local NavigationPoint N, N1;
	local int BestPointDist;

	BestPointDist = RangeRun;
	foreach AllActors (class 'Bot', aBotyMan)
	{
		if ( Mover(aBotyMan.Base) == None && aBotyMan.MoveTarget != None && !aBotyMan.bHidden && aBotyMan.Health > 0
			&& VSize(aBotyMan.velocity) < 80
			&& !FastTrace(aBotyMan.Location,aBotyMan.MoveTarget.Location+vect(0,0,-15)) )
		{
			aBotyMan.BigJump(aBotyMan.MoveTarget);
			aBotyMan.MoveTarget = None;
			aBotyMan.GoToState('Wandering');
		}
		if ( Mover(aBotyMan.Base) != None && VSize(Mover(aBotyMan.Base).velocity) > 0
		&& !aBotyMan.bHidden && aBotyMan.Health > 0)
		{
			aBotyMan.CampTime = 3.000000;
			aBotyMan.GoToState('Roaming','Camp');
		}
		if ( !aBotyMan.bHidden && aBotyMan.Health > 0
		&& aBotyMan.Enemy == None && aBotyMan.Orders != 'Follow'
		&& aBotyMan.MoveTarget == None && aBotyMan.IsInstate('Wandering') )
		{
			if (aBotyMan.Region.Zone.bWaterZone && aBotyMan.Physics != PHYS_Swimming )
				aBotyMan.SetPhysics(PHYS_Swimming);
			
			if ( !NearbyNode(aBotyMan) )
			{
				foreach RadiusActors ( class 'NavigationPoint', N, RangeRun , ABotyMan.Location)
				{
					if (VSize(N.Location-aBotyMan.Location) <= BestPointDist && FastTrace(N.Location,aBotyMan.Location))
					{
						N1 = N;
						BestPointDist = Vsize(N.Location - aBotyMan.Location);
					}
				}
				if ( N1 != None && aBotyMan.FastTrace(N1.Location,aBotyMan.Location))
				{
					aBotyMan.Target = N1;
					aBotyMan.MoveTarget = N1;
					aBotyMan.bCamping = False;
					aBotyMan.PlayRunning();
					aBotyMan.GotoState('Roaming','SpecialNavig');
				}
			}
		}
	}
}

function bool NearbyNode(Bot aBotyMan)
{
	local bool bIsNearby;
	local NavigationPoint P;

	bIsNearby = False;

	foreach RadiusActors( class 'NavigationPoint',P,500,aBotyMan.Location )
	{
		if ( FastTrace(P.Location,aBotyMan.Location) )
		{
			bIsNearby = True;
			break;
		}
	}
	return bIsNearby;
}

state FixSeeker
{
Begin:
	Sleep(3.00);
DoLooping:
	if ( !Level.Game.bGameEnded && bGoodSet )
		CheckLost();
	else
		Goto('TheEnd');
	Sleep(Interval);
	Goto('DoLooping');
TheEnd:
}

defaultproperties
{
	Interval=2.500000
	RangeRun=2000
	InitialState=FixSeeker
}
