class PathsMapper expands KeyPoint;

var PathsActor G;
var Actor HackedZone, LiftActor;
var Shoot_It Shooter;
var Inventory Nasty1, Nasty2;
var NavigationPoint N1, N2, N3, N4, N5, N6, N7, N8, N9, N10, N11, N12, N13, N14; //Assigning points to connect

/*
,'CRYSTALMINE3'
*/

//=====
native(1718) final function bool AddToPackageMap( optional string PkgName );
//=====
native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly ); //Second parameter doesn't exist in 227!
//=====
native(3540) final iterator function PawnActors( class<Pawn> PawnClass, out pawn P, optional float Distance,
optional vector VOrigin, optional bool bHasPRI, optional Pawn StartAt );
//=====
native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible );
//=====
native(3542) final iterator function InventoryActors( class<Inventory> InvClass,
out Inventory Inv, optional bool bSubclasses, optional Actor StartFrom );
//=====
native(3552) final iterator function CollidingActors( class<actor> BaseClass, out actor Actor, float Radius,
optional vector Loc );
//=====
native(3553) final iterator function DynamicActors( class<actor> BaseClass, out actor Actor,
optional name MatchTag );
//=====
native(3560) static final function bool ReplaceFunction( class<Object> ReplaceClass,
class<Object> WithClass, name ReplaceFunction, name WithFunction, optional name InState );
//=====

event PreBeginPlay()
{
	log(Self.name@"Patching Level.",'CRYSTALMINE3');
	G = Spawn( class'PathsActor' );
	ChangeNastyActors();
	AddMHObjectives();
	DoAlterBadPoints();
	SpawnShoters();
	InitialState='PathsMapping';
	log ("PreBeginPlay Completed...",'CRYSTALMINE3');
}

event PostBeginPlay()
{
}

final function SpawnShoters()
{
}

function AddMHObjectives()
{
	local class<Actor> Wp;
	local Actor K1, K2, K3, K4, K5, K6, K7, K8, K9, K10, K11, K12, K13, K14;
	local Actor tmp;

	Wp = class<Actor>( DynamicLoadObject("MonsterHunt.MonsterWaypoint", class'Class', True) );
	if (Wp != None)
	{
		K1 = Spawn(class'MonsterWaypoint',,,vect(-12152,-8944,-224));
		K2 = Spawn(class'MonsterWaypoint',,,vect(-12496,-13536,-896));
		if ( K2 != None )
		{
			MonsterWayPoint(K2).Position = 2;
		}
		K3 = Spawn(class'MonsterWaypoint',,,vect(-14800,-19152,-896));
		if (K3 != None)
		{
			MonsterWayPoint(K3).Position = 3;
		}
		K4 = Spawn(class'MonsterWaypoint',,,vect(-11890,-18728,-832));
		if (K4 != None)
		{
			MonsterWayPoint(K4).Position = 4;
		}
		K5 = Spawn(class'MonsterWaypoint',,,vect(-8192,-15736,-896));
		if (K5 != None)
		{
			MonsterWayPoint(K5).Position = 5;
		}
		K6 = Spawn(class'MonsterWaypoint',,,vect(-3824,-9368,-1248));
		if (K6 != None)
		{
			MonsterWayPoint(K6).Position = 6;
		}
		K7 = Spawn(class'MonsterWaypoint',,,vect(5160,1024,-856));
		if (K7 != None)
		{
			MonsterWayPoint(K7).Position = 7;
		}
		K8 = Spawn(class'MonsterWaypoint',,,vect(14400,1016,-864));
		if (K8 != None)
		{
			MonsterWayPoint(K8).Position = 8;
		}
		K9 = Spawn(class'MonsterWaypoint',,,vect(20624,2112,-1216));
		if (K9 != None)
		{
			MonsterWayPoint(K9).Position = 9;
		}
		K10 = Spawn(class'MonsterWaypoint',,,vect(27032,1152,-960));
		if ( K10 != None )
		{
			MonsterWayPoint(K10).Position = 10;
		}
		K11 = Spawn(class'MonsterWaypoint',,,vect(28032,-872,-1088)); //Future updates at DevPath ?
		if ( K11 != None )
		{
			MonsterWayPoint(K11).Position = 11;
		}
		K12 = Spawn(class'MonsterWaypoint',,,vect(28798,-865,-1088));
		if ( K12 != None )
		{
			MonsterWayPoint(K12).Position = 12;
		}
		K13 = Spawn(class'MonsterWaypoint',,,vect(28030,3166,-1088));
		if ( K13 != None )
		{
			MonsterWayPoint(K13).Position = 13;
		}
		K14 = Spawn(class'MonsterWaypoint',,,vect(28798,3172,-1088));
		if ( K14 != None )
		{
			MonsterWayPoint(K14).Position = 14;
		}
	}
	else
	{
		log("Bork :: Could not find MonsterWayPoint actor...",'CRYSTALMINE3');
	}

}

final function DoAlterBadPoints()
{
	local NavigationPoint A;
	local InventorySpot In;
	local JumpSpot Ju;
	local LiftExit Li;
	local Teleporter Te;
	local PathNode Pa;
	local BlockedPath Bl;
	local SpawnPoint Sp;
	local PlayerStart Pl;
	local int I;
	local string st;

	log ("Attempting to screw up Evil NavigationPoint actors...",'CRYSTALMINE3');
	if ( G != None )
	{
		foreach NavigationActors(class'InventorySpot',In,30,vect(-17376,-7328,3253))
		{
			if (string(In.Name) ~= "InventorySpot420")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-17345,-7248,3253))
		{
			if (string(In.Name) ~= "InventorySpot421")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-17296,-7328,3253))
		{
			if (string(In.Name) ~= "InventorySpot422")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-17424,-7312,3253))
		{
			if (string(In.Name) ~= "InventorySpot423")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-17328,-7472,3253))
		{
			if (string(In.Name) ~= "InventorySpot424")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-18801,-5936,3253))
		{
			if (string(In.Name) ~= "InventorySpot425")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}

		foreach NavigationActors(class'InventorySpot',In,30,vect(-18352,-8208,3410))
		{
			if (string(In.Name) ~= "InventorySpot390")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4904,-1200,-883))
		{
			if (string(In.Name) ~= "InventorySpot348")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4915,-1168,-875))
		{
			if (string(In.Name) ~= "InventorySpot349")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4915,-1132,-875))
		{
			if (string(In.Name) ~= "InventorySpot350")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4915,-1109,-875))
		{
			if (string(In.Name) ~= "InventorySpot351")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4905,-1225,-883))
		{
			if (string(In.Name) ~= "InventorySpot352")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4917,-1168,-875))
		{
			if (string(In.Name) ~= "InventorySpot353")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4919,-1132,-875))
		{
			if (string(In.Name) ~= "InventorySpot354")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4919,-1109,-875))
		{
			if (string(In.Name) ~= "InventorySpot355")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4915,-1079,-875))
		{
			if (string(In.Name) ~= "InventorySpot360")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4918,-1079,-875))
		{
			if (string(In.Name) ~= "InventorySpot361")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-18424,-8228,3408))
		{
			if (string(In.Name) ~= "InventorySpot393")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
//				G.CleanupNavSpecs(In); //It's empty anyway
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
//Miniammo nearby Position 2
		foreach NavigationActors(class'InventorySpot',In,30,vect(-12619,-13576,-870))
		{
			if (string(In.Name) ~= "InventorySpot340")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-12619,-13562,-870))
		{
			if (string(In.Name) ~= "InventorySpot341")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}

		foreach NavigationActors(class'InventorySpot',In,30,vect(-11199,-16656,-875))
		{
			if (string(In.Name) ~= "InventorySpot369")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-11167,-16624,-875))
		{
			if (string(In.Name) ~= "InventorySpot370")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-4992,-912,-619))
		{
			if (string(In.Name) ~= "InventorySpot356")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
// Waypoint in hole
		foreach NavigationActors(class'InventorySpot',In,30,vect(-3264,-9088,-1407))
		{
			if (string(In.Name) ~= "InventorySpot376")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-3383,-8926,-1401))
		{
			if (string(In.Name) ~= "InventorySpot374")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-3309,-8942,-1401))
		{
			if (string(In.Name) ~= "InventorySpot375")
			{
				In.bStatic = False;
				In.bCollideWorld = False;
				In.bCollideWhenPlacing = False;
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				In.SetLocation(In.Location+Vect(0,0,-800));
				In.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'Teleporter',Te,30,vect(-8673,112,-710))
		{
			if (string(Te.Name) ~= "Teleporter1")
			{
				Te.bStatic = False;
				Te.bCollideWorld = False;
				Te.bCollideWhenPlacing = False;
				Te.SetLocation(vect(-8673,257,-710));
				Te.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'Teleporter',Te,30,vect(-2176,-1408,-849))
		{
			if (string(Te.Name) ~= "Teleporter2")
			{
				Te.bStatic = False;
				Te.bCollideWorld = False;
				Te.bCollideWhenPlacing = False;
				Te.SetLocation(vect(-2118,-1328,-848));
				Te.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'Teleporter',Te,30,vect(-12755,-8428,-208))
		{
			if (string(Te.Name) ~= "Teleporter3") //useless
			{
				Te.bStatic = False;
				Te.bCollideWorld = False;
				Te.bCollideWhenPlacing = False;
				Te.SetLocation(Te.Location+vect(0,0,-500));
				G.CleanupNavSpecs(Te);
				break;
			}
		}
		foreach NavigationActors(class'Teleporter',Te,30,vect(-9536,-15376,-736))
		{
			if (string(Te.Name) ~= "Teleporter4") //useless
			{
				Te.bStatic = False;
				Te.bCollideWorld = False;
				Te.bCollideWhenPlacing = False;
				Te.SetLocation(Te.Location+vect(0,0,-500));
				G.CleanupNavSpecs(Te);
				break;
			}
		}

		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20558,-7433,3240))
		{
			if (string(Pl.Name) ~= "PlayerStart0")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20658,-7390,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart2")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20632,-7633,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart3")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20686,-7289,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart4")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20638,-7529,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart17")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20574,-7225,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart18")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20617,-7757,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart19")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20601,-7889,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart20")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20655,-8025,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart22")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20782,-7497,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart23")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(vect(-20504,-7548,3360)); //Outta rat hole
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20511,-7945,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart24")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-20622,-7033,3248))
		{
			if (string(Pl.Name) ~= "PlayerStart25")
			{
				Pl.bStatic = False;
				Pl.bCollideWhenPlacing = False;
				Pl.bCollideWorld = False;
				Pl.SetLocation(Pl.Location + vect(0,0,180));
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = True;
				break;
			}
		}

	}
}

final function DoFakeNavigation()
{
	local RadiusMove RM0, RM1, RM2, RM3, RM4, RM5, RM6, RM7, RM8, RM9, RM10, RM11, RM12, RM13, RM14, RM15,
		RM16, RM17, RM18, RM19, RM20, RM21, RM22, RM23, RM24, RM25;
	local Dispatcher Ds0, Ds1, Ds2;

	RM0 = Spawn(class'RadiusMove',,,vect(-20593,-7035,3249));
	if ( RM0 != None )
	{
		RM0.RadiusRange=400;
		RM0.TimePush=2.500000;
		RM0.NamedActor="SmartNode0";
		RM0.Tag='';
		RM0.bEnabled = True;
		RM0 = None;
	}
	RM1 = Spawn(class'RadiusMove',,,vect(-20597,-7828,3249));
	if ( RM1 != None )
	{
		RM1.RadiusRange=400;
		RM1.TimePush=2.500000;
		RM1.NamedActor="SmartNode0";
		RM1.Tag='';
		RM1.bEnabled = True;
		RM1 = None;
	}

}

final function ChangeNastyActors()
{
	local Actor A;

	foreach AllActors(class 'Actor', A) //In order of iterating
	{
		if (string(A.Name) ~= "Trigger10") // Position 171
		{
			A.Tag = '10_Trigger';
			A.SetLocation(vect(-12378,-11456,-184));
			Trigger(A).RepeatTriggerTime = 12.500000;
			Trigger(A).ReTriggerDelay = 12.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover21") // Position 322
		{
			Mover(A).bUseTriggered = False; //Not gonna happen
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Mover23") // Position 342
		{
			Mover(A).bUseTriggered = False; //Good Night!
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_CrushWhenEncroach;
			Mover(A).BumpType = BT_PawnBump;
			Mover(A).EncroachDamage = 10000;
			continue;
		}
		if (string(A.Name) ~= "Trigger12") // Position 431
		{
			A.SetCollisionSize(256,200);
			continue;
		}
		if (string(A.Name) ~= "Mover12") // Position 434
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Mover14") // Position 435
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Mover22") // Position 461
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Trigger23") // Position 465
		{
			A.SetLocation(vect(-5634,1064,-864));
			continue;
		}
		if (string(A.Name) ~= "Trigger7") // Position 466
		{
			A.SetLocation(vect(-6430,920,-864));
			continue;
		}
		if (string(A.Name) ~= "Mover13") // Position 549 - Boat hurts and NEVER RETURN
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_CrushWhenEncroach;
			Mover(A).BumpType = BT_PawnBump;
			Mover(A).EncroachDamage = 50;
			continue;
		}
		if (string(A.Name) ~= "MonsterEvent18") // Position 561
		{
			MonsterEvent(A).Message = "Teleporter B2 is now active.";
			continue;
		}
		if (string(A.Name) ~= "Mover19") // Position 1070
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Trigger28") // Position 1118
		{
			A.SetLocation(vect(-204,124,-864));
			continue;
		}
		if (string(A.Name) ~= "Trigger15") // Position 1215 - Useless and only bugging A.I.
		{
			A.Event = 'ShitFloatingOverSea';
			A.bGameRelevant = False;
			A.OddsOfAppearing = 0.000000;
			A.LifeSpan = 2.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover16") // Position 1307
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			continue;
		}
		if (string(A.Name) ~= "Mover28") // Position 1394
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			continue;
		}
		if (string(A.Name) ~= "Mover27") // Position 1395
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			continue;
		}
		if (string(A.Name) ~= "Trigger24") // Position 1396
		{
			Trigger(A).Event = 'WC_Stuff';
			A.bGameRelevant = False;
			A.OddsOfAppearing = 0.000000;
			A.LifeSpan = 2.000000;
			continue;
		}
		if (string(A.Name) ~= "Trigger20") // Position 1397
		{
			A.SetCollisionSize(200,40);
			A.SetLocation(vect(1980,1534,-912));
			Trigger(A).ReTriggerDelay = 13.000000;
			Trigger(A).RepeatTriggerTime = 13.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover25") // Position 1398
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			continue;
		}
		if (string(A.Name) ~= "Mover18") // Position 1399
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			continue;
		}
		if (string(A.Name) ~= "Trigger21") // Position 1400
		{
			A.SetCollisionSize(200,40);
			A.SetLocation(vect(1980,510,-912));
			Trigger(A).ReTriggerDelay = 13.000000;
			Trigger(A).RepeatTriggerTime = 13.000000;
			continue;
		}
		if (string(A.Name) ~= "Trigger22") // Position 1401
		{
			Trigger(A).Event = 'WC_Stuff';
			A.bGameRelevant = False;
			A.OddsOfAppearing = 0.000000;
			A.LifeSpan = 2.000000;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool11") // Position 1455
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool4") // Position 1456
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool5") // Position 1457
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool0") // Position 1487
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool1") // Position 1488
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool2") // Position 1489
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "Trigger25") // Position 1585
		{
			A.SetLocation(vect(-370,1452,-864));
			continue;
		}
		if (string(A.Name) ~= "Mover32") // Position 1691
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Mover30") // Position 1707
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			continue;
		}
		if (string(A.Name) ~= "Trigger26") // Position 1829 - useless - door opens once anyway
		{
			Trigger(A).Event = 'WC_Stuff';
			A.bGameRelevant = False;
			A.OddsOfAppearing = 0.000000;
			A.LifeSpan = 2.000000;
			continue;
		}
		if (string(A.Name) ~= "Trigger27") // Position 1830
		{
			Trigger(A).Event = 'WC_Stuff';
			A.bGameRelevant = False;
			A.OddsOfAppearing = 0.000000;
			A.LifeSpan = 2.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover15") // Position 1853 - First Lift
		{
			Mover(A).bUseTriggered = False;
			Mover(A).DelayTime = 2;
			Mover(A).StayOpenTime = 8; //Christmas is coming until crap does a round - during this time no support from respawners
			Mover(A).MoverEncroachType = ME_CrushWhenEncroach;
			Mover(A).BumpType = BT_PawnBump;
			Mover(A).EncroachDamage = 10000;
			Mover(A).Group = A.Name;
			continue;
		}
		if (string(A.Name) ~= "Trigger31") // Position 1869
		{
			A.Tag = '31_Trigger';
			A.SetLocation(vect(-18382,-7416,3248)); //Not gonna look at Bot mooing at wall...
			Trigger(A).RepeatTriggerTime = 20.000000;
			Trigger(A).ReTriggerDelay = 20.000000;
			A.PostBeginPlay();
			continue;
		}
		if (string(A.Name) ~= "Mover29") // Position 1932
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).DelayTime = 1;
			Mover(A).StayOpenTime = 2; //Christmas is coming until crap does a round - during this time no support from respawners
			Mover(A).BumpType = BT_PawnBump;
			Mover(A).Tag = 'Dispatsjer';
			continue;
		}
		if (string(A.Name) ~= "PulseGun0") // Position 1960
		{
			Inventory(A).RespawnTime = 7.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover0") // Position 1984
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Mover35") // Position 2019
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Mover36") // Position 2020
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "Trigger40") // Position 2085 - Pointless message if already triggered
		{
			Trigger(A).Tag = 'TempleEntranceDoor';
			Trigger(A).InitialState = 'OtherTriggerTurnsOff';
			continue;
		}
		if (string(A.Name) ~= "PAmmo3") // Position 2104
		{
			Inventory(A).RespawnTime = 7.000000;
			continue;
		}
		if (string(A.Name) ~= "PAmmo7") // Position 2105
		{
			Inventory(A).RespawnTime = 7.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover0") // Position 2105
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool3") // Position 2238
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool6") // Position 2239
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool7") // Position 2240
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool9") // Position 2241
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool10") // Position 2242
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool12") // Position 2243
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool13") // Position 2244
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool14") // Position 2245
		{
			A.SetCollisionSize(30,30);
			Pawn(A).PeripheralVision = -0.5;
			continue;
		}
		if (string(A.Name) ~= "Mover38") // Position 2289
		{
			Mover(A).bUseTriggered = False;
			Mover(A).Group = A.Name;
			Mover(A).MoverEncroachType = ME_IgnoreWhenEncroach;
			continue;
		}
	}
}

final function SpawnPaths()
{
	local PathBlocker B;

	class'SmartNode'.default.bStatic = False;
	class'SmartNode'.default.bNoDelete = False;
	class'FSmartNode'.default.bStatic = False;
	class'FSmartNode'.default.bNoDelete = False;
	class'E_LiftExit'.default.bStatic = False;
	class'E_LiftCenter'.default.bStatic = False;

	if ( G != None )
	{
		Spawn(class'SmartNode',,,vect(-20298,-7422,3244));
		Spawn(class'SmartNode',,,vect(-19758,-7412,3244));
/*
		Spawn(class'SmartNode',,,vect(-19633,-6822,3244));
		Spawn(class'SmartNode',,,vect(-19112,-6688,3244));
		Spawn(class'SmartNode',,,vect(-18416,-6904,3244));
		Spawn(class'SmartNode',,,vect(-19675,-7624,3244));
*/
		Spawn(class'SmartNode',,,vect(-18224,-7704,3244));
		Spawn(class'SmartNode',,,vect(-17506,-7432,-216));
		Spawn(class'SmartNode',,,vect(-17032,-7424,-216));
		Spawn(class'SmartNode',,,vect(-16696,-7592,-216));
		Spawn(class'SmartNode',,,vect(-16344,-7544,-216));
		Spawn(class'SmartNode',,,vect(-16256,-7312,-216));
		Spawn(class'SmartNode',,,vect(-15912,-7480,-216));
		Spawn(class'SmartNode',,,vect(-15440,-7432,-216));
		Spawn(class'SmartNode',,,vect(-15080,-7432,-216));
		Spawn(class'SmartNode',,,vect(-14656,-7424,-216));
		Spawn(class'SmartNode',,,vect(-14272,-7424,-216));
		Spawn(class'SmartNode',,,vect(-13912,-7424,-216));
		Spawn(class'SmartNode',,,vect(-13496,-7432,-216));
		Spawn(class'SmartNode',,,vect(-12952,-7432,-216));
		Spawn(class'SmartNode',,,vect(-12872,-6752,-216));
		Spawn(class'SmartNode',,,vect(-12472,-6848,-216));
		Spawn(class'SmartNode',,,vect(-11629,-6808,-216));
		Spawn(class'SmartNode',,,vect(-11592,-7928,-216));
		Spawn(class'SmartNode',,,vect(-12168,-8184,-216));
		Spawn(class'SmartNode',,,vect(-12760,-8008,-216));
		Spawn(class'SmartNode',,,vect(-12154,-9025,-216));
		N2 = Spawn(class'FSmartNode',,,vect(-17800,-7432,-216));
		Spawn(class'FSmartNode',,,vect(-12160,-8472,-216));
		Spawn(class'FSmartNode',,,vect(-12165,-8762,-216));
		N1 = Spawn(class'E_LiftExit',,,vect(-18392,-7448,-216));
		if (N1 != None)
		{
			LiftExit(N1).LiftTag = 'BigMineMover';
			N1.PostBeginPlay();
		}
		N3 = Spawn(class'E_LiftExit',,,vect(-18368,-7304,3240));
		if (N3 != None)
		{
			LiftExit(N3).LiftTag = 'BigMineMover';
			LiftExit(N3).LiftTrigger = '31_Trigger';
			N3.PostBeginPlay();
		}
		N4 = Spawn(class'E_LiftCenter',,,vect(-18749,-7330,3214));
		if (N4 != None)
		{
			LiftCenter(N4).LiftTag = 'BigMineMover';
			N4.PostBeginPlay();
		}
		Spawn(class'SmartNode',,,vect(-12704,-9448,-216));
		Spawn(class'SmartNode',,,vect(-11704,-9440,-216));
		Spawn(class'SmartNode',,,vect(-11632,-10448,-216));
		Spawn(class'SmartNode',,,vect(-12680,-10528,-216));
		Spawn(class'SmartNode',,,vect(-12184,-10840,-216));
		Spawn(class'SmartNode',,,vect(-11721,-12068,-888));
		Spawn(class'SmartNode',,,vect(-12458,-12552,-888));

		Spawn(class'FSmartNode',,,vect(-12169,-11136,-216));
		Spawn(class'FSmartNode',,,vect(-12161,-11328,-216));
		N5 = Spawn(class'E_LiftExit',,,vect(-12362,-11456,-216));
		B = Spawn(class'PathBlocker',,,vect(-12362,-11456,-218));
		if (B != None)
		{
			B.Tag = 'Quick1';
		}
		if (N5 != None)
		{
			LiftExit(N5).LiftTag = 'MineLift1';
			LiftExit(N5).LiftTrigger = '10_Trigger';
			N5.PostbeginPlay();
		}
		N6 = Spawn(class'E_LiftExit',,,vect(-12129,-11848,-888));
		if ( N6 != None )
		{
			LiftExit(N6).LiftTag = 'MineLift1';
			N6.PostBeginPlay();
		}
		N7 = Spawn(class'FSmartNode',,,vect(-12454,-12255,-888));
		N8 = Spawn(class'E_LiftCenter',,,vect(-12182,-11582,-236));
		if ( N8 != None )
		{
			LiftCenter(N8).LiftTag = 'MineLift1';
			N8.PostBeginPlay();
		}

		Spawn(class'SmartNode',,,vect(-11872,-13632,-888));
		Spawn(class'SmartNode',,,vect(-12077,-14267,-888));
		Spawn(class'SmartNode',,,vect(-12045,-14888,-888));
		Spawn(class'SmartNode',,,vect(-12544,-15080,-888));
		Spawn(class'SmartNode',,,vect(-12520,-15712,-888));
		Spawn(class'SmartNode',,,vect(-11416,-16464,-864));
		Spawn(class'SmartNode',,,vect(-11959,-16544,-888));
		Spawn(class'SmartNode',,,vect(-11024,-16096,-888));
		Spawn(class'SmartNode',,,vect(-10280,-16536,-888));
		Spawn(class'SmartNode',,,vect(-10320,-17104,-888));
		Spawn(class'SmartNode',,,vect(-10136,-17680,-920));
		Spawn(class'SmartNode',,,vect(-9976,-18240,-888));
		Spawn(class'SmartNode',,,vect(-9992,-18848,-888));
		Spawn(class'SmartNode',,,vect(-10544,-19072,-888));
		Spawn(class'SmartNode',,,vect(-11064,-19000,-888));
		Spawn(class'SmartNode',,,vect(-11627,-18886,-888)); //
		Spawn(class'SmartNode',,,vect(-10808,-17552,-888));
		Spawn(class'SmartNode',,,vect(-11272,-17744,-888));
		Spawn(class'SmartNode',,,vect(-11414,-18308,-888));
		Spawn(class'SmartNode',,,vect(-12199,-18964,-888)); //
		Spawn(class'SmartNode',,,vect(-12872,-18728,-888));
		Spawn(class'SmartNode',,,vect(-13536,-18744,-888));
		Spawn(class'SmartNode',,,vect(-14259,-18696,-888));
		Spawn(class'SmartNode',,,vect(-14802,-18744,-888));
		Spawn(class'SmartNode',,,vect(-15400,-18808,-888));
		Spawn(class'SmartNode',,,vect(-9408,-18952,-888));
		Spawn(class'SmartNode',,,vect(-8992,-18944,-856));
		Spawn(class'SmartNode',,,vect(-8696,-18760,-888));
		Spawn(class'SmartNode',,,vect(-8680,-19112,-888));
		Spawn(class'SmartNode',,,vect(-9512,-16576,-888));
		Spawn(class'SmartNode',,,vect(-9208,-16168,-888));
		Spawn(class'SmartNode',,,vect(-8664,-16192,-888));
		Spawn(class'SmartNode',,,vect(-8216,-16024,-888));
		Spawn(class'SmartNode',,,vect(-8184,-16632,-888));
		Spawn(class'SmartNode',,,vect(-8296,-17048,-888));
		Spawn(class'SmartNode',,,vect(-9096,-15848,-760));
		Spawn(class'SmartNode',,,vect(-8776,-15672,-760));
		Spawn(class'SmartNode',,,vect(-8704,-15200,-752));
		Spawn(class'SmartNode',,,vect(-9480,-15712,-760));
		Spawn(class'SmartNode',,,vect(-9405,-15369,-752));
		Spawn(class'SmartNode',,,vect(-9600,-14888,-752));

		Spawn(class'FSmartNode',,,vect(-11925,-18728,-824));
		Spawn(class'FSmartNode',,,vect(-11906,-18936,-888));
		Spawn(class'FSmartNode',,,vect(-14235,-19091,-701));
		Spawn(class'FSmartNode',,,vect(-14380,-19077,-800));
		Spawn(class'FSmartNode',,,vect(-14488,-19024,-856));
		Spawn(class'FSmartNode',,,vect(-14689,-18984,-888));
		Spawn(class'FSmartNode',,,vect(-10044,-16528,-888));
		Spawn(class'FSmartNode',,,vect(-9792,-16544,-888));

//Boat route through water

		Spawn(class'SmartNode',,,vect(-9184,-15640,-760));
		Spawn(class'SmartNode',,,vect(-9148,-15526,-856));
		Spawn(class'SmartNode',,,vect(-9299,-14540,-856));
		Spawn(class'SmartNode',,,vect(-9304,-14007,-856));
		Spawn(class'SmartNode',,,vect(-9222,-13535,-856));
		Spawn(class'SmartNode',,,vect(-9287,-13011,-856));
		Spawn(class'SmartNode',,,vect(-9352,-12293,-856));
		Spawn(class'SmartNode',,,vect(-9250,-11609,-856));
		Spawn(class'SmartNode',,,vect(-9128,-10905,-856));
		Spawn(class'SmartNode',,,vect(-9322,-10217,-856));
		Spawn(class'SmartNode',,,vect(-9371,-9483,-856));
		Spawn(class'SmartNode',,,vect(-9395,-8771,-856));
		Spawn(class'SmartNode',,,vect(-9382,-8074,-856));
		Spawn(class'SmartNode',,,vect(-9374,-7352,-856));
		Spawn(class'SmartNode',,,vect(-9519,-6664,-856));
		Spawn(class'SmartNode',,,vect(-9511,-5993,-856));
		Spawn(class'SmartNode',,,vect(-9503,-5290,-856));
		Spawn(class'SmartNode',,,vect(-9524,-4659,-856));
		Spawn(class'SmartNode',,,vect(-9516,-3947,-856));
		Spawn(class'SmartNode',,,vect(-9508,-3205,-856));
		Spawn(class'SmartNode',,,vect(-9534,-2502,-856));
		Spawn(class'SmartNode',,,vect(-9535,-1786,-856));
		Spawn(class'SmartNode',,,vect(-9566,-1091,-856));
		Spawn(class'SmartNode',,,vect(-9558,-395,-856));
		Spawn(class'SmartNode',,,vect(-9525,306,-856)); //
		Spawn(class'SmartNode',,,vect(-9533,784,-856));
		Spawn(class'SmartNode',,,vect(-9166,943,-741));
		Spawn(class'FSmartNode',,,vect(-9208,-13371,-856));
		Spawn(class'FSmartNode',,,vect(-9210,-13241,-856));

//From boat - Activate teleporter to next WayPoint - by Player/Bot

		Spawn(class'SmartNode',,,vect(-8625,488,-752));
		Spawn(class'SmartNode',,,vect(-8784,1104,-744));
		Spawn(class'SmartNode',,,vect(-8944,1352,-888));
		Spawn(class'SmartNode',,,vect(-8688,2002,-888));
		Spawn(class'SmartNode',,,vect(-8082,2364,-888));
		Spawn(class'SmartNode',,,vect(-7415,2576,-888));
		Spawn(class'SmartNode',,,vect(-6733,2327,-888));
		Spawn(class'SmartNode',,,vect(-6233,1823,-888));
		Spawn(class'SmartNode',,,vect(-5944,1224,-888));
		Spawn(class'SmartNode',,,vect(-5974,672,-888));
		Spawn(class'SmartNode',,,vect(-5643,79,-888));
		Spawn(class'SmartNode',,,vect(-5136,-304,-888));
		Spawn(class'SmartNode',,,vect(-4497,-744,-880));
		Spawn(class'SmartNode',,,vect(-4524,-1269,-888));
		Spawn(class'SmartNode',,,vect(-4571,-1993,-888));
		Spawn(class'SmartNode',,,vect(-5312,-1608,-888));
		Spawn(class'SmartNode',,,vect(-5824,-1312,-888));
		Spawn(class'SmartNode',,,vect(-6452,-1192,-888));
		Spawn(class'SmartNode',,,vect(-6984,-1000,-888));
		Spawn(class'SmartNode',,,vect(-6576,-1608,-888));
		Spawn(class'SmartNode',,,vect(-6496,-2112,-888));
		Spawn(class'SmartNode',,,vect(-6000,-2368,-888));
		Spawn(class'SmartNode',,,vect(-5440,-2120,-888));
		Spawn(class'SmartNode',,,vect(-4936,-2064,-888));
		Spawn(class'SmartNode',,,vect(-5791,-3030,-888));
		Spawn(class'SmartNode',,,vect(-5432,-3448,-888));
		Spawn(class'SmartNode',,,vect(-4817,-3336,-888));
		Spawn(class'SmartNode',,,vect(-4272,-3096,-888));
		Spawn(class'SmartNode',,,vect(-4152,-2640,-888));
		Spawn(class'SmartNode',,,vect(-4612,-2522,-888));
		Spawn(class'SmartNode',,,vect(-4544,-128,-888));
		Spawn(class'SmartNode',,,vect(-3943,-80,-888));
		Spawn(class'SmartNode',,,vect(-3480,-168,-888));
		Spawn(class'SmartNode',,,vect(-3352,-600,-888));
		Spawn(class'SmartNode',,,vect(-3424,-1200,-888));
		Spawn(class'SmartNode',,,vect(-5336,-1176,-888));
		Spawn(class'SmartNode',,,vect(-5331,-3942,-888));
		Spawn(class'SmartNode',,,vect(-4425,-3923,-888));
		Spawn(class'SmartNode',,,vect(-4856,-4304,-888));
		Spawn(class'SmartNode',,,vect(-4728,-4968,-888));
		Spawn(class'SmartNode',,,vect(-4416,-5624,-888));
		Spawn(class'SmartNode',,,vect(-3864,-6040,-888));
		Spawn(class'SmartNode',,,vect(-3390,-6544,-888));
		Spawn(class'SmartNode',,,vect(-2808,-6096,-888));
		Spawn(class'SmartNode',,,vect(-3408,-7088,-888));
		Spawn(class'SmartNode',,,vect(-3528,-7600,-1112));
		Spawn(class'SmartNode',,,vect(-3384,-8080,-1240));
		Spawn(class'SmartNode',,,vect(-3296,-8456,-1248));
		Spawn(class'SmartNode',,,vect(-3424,-8768,-1384));
		Spawn(class'SmartNode',,,vect(-2800,-8312,-1240));
		Spawn(class'SmartNode',,,vect(-2400,-8560,-1240));
		Spawn(class'SmartNode',,,vect(-2304,-9072,-1240));
		Spawn(class'SmartNode',,,vect(-2600,-9608,-1240));
		Spawn(class'SmartNode',,,vect(-3040,-9888,-1272));
		Spawn(class'SmartNode',,,vect(-3504,-9840,-1240));
		Spawn(class'SmartNode',,,vect(-4040,-8256,-1240));
		Spawn(class'SmartNode',,,vect(-2238,-5732,-888));
		Spawn(class'SmartNode',,,vect(-1925,-5057,-888));
		Spawn(class'SmartNode',,,vect(-1830,-4350,-888));
		Spawn(class'SmartNode',,,vect(-1662,-3758,-888));
		Spawn(class'SmartNode',,,vect(-1371,-2608,-888));
		Spawn(class'SmartNode',,,vect(-1384,-2016,-888));
		Spawn(class'SmartNode',,,vect(-1873,-1713,-888));
		Spawn(class'SmartNode',,,vect(-1480,-1224,-888));
		Spawn(class'SmartNode',,,vect(-1666,-608,-888));
		Spawn(class'SmartNode',,,vect(-1725,-75,-888));
		Spawn(class'FSmartNode',,,vect(-6006,1016,-856));
		Spawn(class'FSmartNode',,,vect(-6184,856,-888));

//From PathNode near False Event message

		Spawn(class'SmartNode',,,vect(-1115,736,-888));
		Spawn(class'FSmartNode',,,vect(-312,1128,-856));
		Spawn(class'FSmartNode',,,vect(-261,1026,-856));
		Spawn(class'SmartNode',,,vect(-579,1149,-885));
		Spawn(class'SmartNode',,,vect(6,943,-885));
		Spawn(class'SmartNode',,,vect(183,410,-885));
		Spawn(class'SmartNode',,,vect(368,-76,-885));
		Spawn(class'SmartNode',,,vect(1168,120,-885));
		Spawn(class'SmartNode',,,vect(108,1546,-885));
		Spawn(class'SmartNode',,,vect(274,1969,-885));
		Spawn(class'SmartNode',,,vect(1217,1873,-885));
		Spawn(class'SmartNode',,,vect(1264,1241,-885));
		Spawn(class'SmartNode',,,vect(1270,820,-885));
		Spawn(class'SmartNode',,,vect(1649,522,-917));
		Spawn(class'SmartNode',,,vect(1622,1543,-917));
		Spawn(class'FSmartNode',,,vect(1896,1544,-917));
		Spawn(class'FSmartNode',,,vect(2083,1542,-917));
		Spawn(class'FSmartNode',,,vect(1889,513,-917));
		Spawn(class'FSmartNode',,,vect(2067,509,-917));
		Spawn(class'SmartNode',,,vect(2256,488,-920));
		Spawn(class'SmartNode',,,vect(2287,1548,-920));
		Spawn(class'SmartNode',,,vect(2696,1232,-888));
		Spawn(class'SmartNode',,,vect(2696,816,-888));
		Spawn(class'SmartNode',,,vect(2832,128,-888));
		Spawn(class'SmartNode',,,vect(3653,94,-888));
		Spawn(class'SmartNode',,,vect(2784,1872,-888));
		Spawn(class'SmartNode',,,vect(3779,1895,-888));
		Spawn(class'SmartNode',,,vect(3964,616,-888));
		Spawn(class'SmartNode',,,vect(4019,1378,-888));
		Spawn(class'SmartNode',,,vect(4530,1025,-888));
		Spawn(class'FSmartNode',,,vect(4809,1025,-848));
		Spawn(class'FSmartNode',,,vect(5099,1024,-848));
		Spawn(class'SmartNode',,,vect(5384,1024,-848));
		Spawn(class'SmartNode',,,vect(6100,999,-888));
		Spawn(class'SmartNode',,,vect(6825,1048,-888));
		Spawn(class'SmartNode',,,vect(8480,1280,-888));
		Spawn(class'SmartNode',,,vect(9000,960,-888));
		Spawn(class'SmartNode',,,vect(9600,725,-888));
		Spawn(class'SmartNode',,,vect(10271,725,-888));
		Spawn(class'SmartNode',,,vect(11008,992,-888));
		Spawn(class'SmartNode',,,vect(11744,1042,-888));
		Spawn(class'SmartNode',,,vect(12485,980,-888));
		Spawn(class'SmartNode',,,vect(13196,1032,-888));
		Spawn(class'SmartNode',,,vect(13845,1047,-888));
		Spawn(class'FSmartNode',,,vect(14071,1040,-856));
		Spawn(class'FSmartNode',,,vect(14352,1040,-856));
		Spawn(class'SmartNode',,,vect(14576,952,-856));
		Spawn(class'SmartNode',,,vect(15024,784,-1032));
		Spawn(class'SmartNode',,,vect(15289,102,-1033));
		Spawn(class'SmartNode',,,vect(15912,-232,-1040));
		Spawn(class'SmartNode',,,vect(16464,-416,-1032));
		Spawn(class'SmartNode',,,vect(17024,-176,-1032));
		Spawn(class'SmartNode',,,vect(17456,0,-1024));
		Spawn(class'SmartNode',,,vect(17664,592,-1040));
		Spawn(class'SmartNode',,,vect(18416,1034,-728)); // bad ledge here
		Spawn(class'SmartNode',,,vect(17816,984,-1040));
		Spawn(class'SmartNode',,,vect(17664,1432,-1040));
		Spawn(class'SmartNode',,,vect(17456,1936,-1040));
		Spawn(class'SmartNode',,,vect(18576,520,-728));
		Spawn(class'SmartNode',,,vect(18584,1344,-728));
		Spawn(class'SmartNode',,,vect(15040,1264,-1040));
		Spawn(class'SmartNode',,,vect(15224,1752,-1032));
		Spawn(class'SmartNode',,,vect(15432,2128,-1024));
		Spawn(class'SmartNode',,,vect(16080,2400,-1024));
		Spawn(class'SmartNode',,,vect(16576,2416,-1032));
		Spawn(class'SmartNode',,,vect(18560,-696,-1368));
		Spawn(class'SmartNode',,,vect(18560,-64,-1040));
		Spawn(class'SmartNode',,,vect(18988,-768,-1368));
		Spawn(class'SmartNode',,,vect(19528,-760,-1368));
		Spawn(class'SmartNode',,,vect(20216,-736,-1392));
		Spawn(class'SmartNode',,,vect(20694,-187,-1480));
		Spawn(class'SmartNode',,,vect(21301,172,-1480));
		Spawn(class'SmartNode',,,vect(20640,2088,-1208));
		Spawn(class'SmartNode',,,vect(20488,2072,-1208));
		Spawn(class'SmartNode',,,vect(20344,1718,-1481));
		Spawn(class'SmartNode',,,vect(20005,2193,-1481));
		Spawn(class'SmartNode',,,vect(20453,2657,-1481));
		Spawn(class'SmartNode',,,vect(20979,2665,-1481));
		Spawn(class'SmartNode',,,vect(21683,2583,-1481));
		Spawn(class'SmartNode',,,vect(22369,2591,-1481));
		Spawn(class'SmartNode',,,vect(22913,2162,-1481));
		Spawn(class'SmartNode',,,vect(23008,1485,-1481));
		Spawn(class'SmartNode',,,vect(23099,1124,-1481));
		Spawn(class'SmartNode',,,vect(23872,1120,-968));
		Spawn(class'SmartNode',,,vect(23624,872,-1136));
		Spawn(class'FSmartNode',,,vect(24098,1163,-952));
		Spawn(class'FSmartNode',,,vect(24352,1152,-952));
		Spawn(class'SmartNode',,,vect(24616,1154,-952));
		Spawn(class'SmartNode',,,vect(25568,1155,-949));
		Spawn(class'SmartNode',,,vect(25086,1429,-949));
		Spawn(class'SmartNode',,,vect(26165,1161,-949));
		Spawn(class'SmartNode',,,vect(26610,859,-949));
		Spawn(class'SmartNode',,,vect(27137,1146,-949));
		Spawn(class'SmartNode',,,vect(27471,1378,-949));
		Spawn(class'SmartNode',,,vect(27491,917,-949));
		Spawn(class'SmartNode',,,vect(27480,1699,-949));
		Spawn(class'SmartNode',,,vect(27610,339,-949));
		Spawn(class'SmartNode',,,vect(27930,396,-1077));
		Spawn(class'SmartNode',,,vect(27628,1982,-949));
		Spawn(class'SmartNode',,,vect(27913,1924,-1077));
		Spawn(class'SmartNode',,,vect(28417,1821,-1077));
		Spawn(class'SmartNode',,,vect(28416,487,-1077));
		Spawn(class'FSmartNode',,,vect(28033,2160,-1077));
		Spawn(class'FSmartNode',,,vect(28035,2308,-1077));
		Spawn(class'FSmartNode',,,vect(28803,2163,-1077));
		Spawn(class'FSmartNode',,,vect(28803,2289,-1077));
		Spawn(class'FSmartNode',,,vect(28033,140,-1077));
		Spawn(class'FSmartNode',,,vect(28802,144,-1077));
		Spawn(class'FSmartNode',,,vect(28802,-10,-1077));
		Spawn(class'FSmartNode',,,vect(28033,-1,-1077));
		Spawn(class'SmartNode',,,vect(28904,370,-1077));
		Spawn(class'SmartNode',,,vect(28881,1925,-1077));
		Spawn(class'SmartNode',,,vect(29214,1997,-949));
		Spawn(class'SmartNode',,,vect(29303,1553,-949));
		Spawn(class'FSmartNode',,,vect(29570,1153,-949));
		Spawn(class'FSmartNode',,,vect(29860,1153,-949));
		Spawn(class'SmartNode',,,vect(30157,1153,-949));
		Spawn(class'SmartNode',,,vect(28031,-244,-1077));
		Spawn(class'SmartNode',,,vect(28801,-252,-1077));
		Spawn(class'SmartNode',,,vect(28800,2541,-1077));
		Spawn(class'SmartNode',,,vect(28033,2524,-1077));

	}
}

function RestoreOriginal()
{
	local Actor A;
	local SpawnPoint Sp;

}

function DoReconnect()
{
	local NavigationPoint A;
	local InventorySpot In;
	local JumpSpot Ju;
	local LiftExit Li;
	local Teleporter Te;
	local PathNode Pa;
	local SpawnPoint Sp;
	local PlayerStart Pl;
	local int I;
	local string st;
	local Rotator NewRot;

	log ("Perform Post Navigation Mapping Connectors.",'CRYSTALMINE3');

	if ( G != None )
	{
		if ( N1 != None && N2 != None )
			G.EzConnectNavigationPoints( N1,N2,,True );
		if ( N6 != None && N7 != None )
		{
//			log ("Connect"@N6.Name@"with"@N7.Name@"at distance"@VSize(N6.Location-N7.Location));
			G.EzConnectNavigationPoints( N6,N7,,True );
		}
	}
}

auto state PathsMapping
{
Begin:
	Sleep(0.2);
	log ("Navigation processing done, spawning new paths...",'CRYSTALMINE3');
	SpawnPaths();
	Spawn(class'SomeActor');
	Sleep(0.0);
	DoFakeNavigation();
	Sleep(0.2);
	DoReconnect();
	Spawn(class'TelPathsHacker');
	RestoreOriginal();
	Spawn(class'NoLost');
	GotoState('');
}

defaultproperties
{
	bMovable=False
	bStatic=False
	bGameRelevant=True
}
