//=============================================================================
// RadiusMove.
//=============================================================================
class RadiusMove expands Actor;

var bool bEnabled;
var int RadiusRange;
var float TimePush;
var string NamedActor;
var Actor AquiredActor;

event PostBeginPlay()
{
	InitialState = 'SendItThere';
	bHidden = True;
	SetCollision(False,False,False);
}

function Trigger(Actor Other, Pawn EventInstigator)
{
	bEnabled = !bEnabled;
	if ( bEnabled )
		GoToState('SendItThere','LoopCheck');
	log (Self.Name$" active!");
}

function MoveIt()
{
	local Bot B;
	local Actor A;

	if (Level.Game.bGameEnded)
	{
		Destroy();
		return;
	}
	foreach RadiusActors (class 'Bot',B,RadiusRange,Location)
	{
		if ( !B.bHidden )
		{
			if ( B.Health > 0 && ( B.Enemy == None || B.IsInState('Wandering')) )
				if ( FastTrace(B.Location,AquiredActor.Location) )
				{
					B.ClearPaths();
					B.MoveTarget = AquiredActor;
					B.PlayRunning();
					B.GotoState('Roaming','SpecialNavig');
					break;
				}
		}
	}
}

final function AquireActor()
{
	local Actor A;

	foreach RadiusActors( class 'Actor', A, RadiusRange*2, Location )
//	foreach AllActors( class 'Actor', A )
	{
		if ( AquiredActor == None )
		{
			if ( string(A.Name) ~= NamedActor )
			{
				AquiredActor = A;
				log (Self.Name@"found target actor"@AquiredActor.Name);
			}
		}
		else
			continue;
	}
}

function ShowGoal()
{
	local bool bShown;
	local TournamentPlayer P;

	BroadcastMessage(Self.Name$"Showing Self and the Target.",False,'MonsterCriticalEvent');

	foreach RadiusActors(class 'TournamentPlayer', P, 1000, Location)
	{
		if (!bShown)
		{
			bHidden = False;
			if ( AquiredActor != None )
			{
				AquiredActor.bHidden = False;
			}
			bShown = True;
		}
	}
}

function HideGoal()
{
	local bool bHiddenG;
	local TournamentPlayer P;

	BroadcastMessage(Self.Name$"Hidding Self and the Target.",False,'MonsterCriticalEvent');

	foreach RadiusActors(class 'TournamentPlayer', P, 1000, Location)
	{
		if (!bHiddenG)
		{
			bHidden = True;
			if ( AquiredActor != None )
			{
				AquiredActor.bHidden = True;
			}
			bHiddenG = True;
		}
	}
}

Auto State SendItThere
{
Begin:
	log (Self.Name$" RadiusRange "$RadiusRange );
	log (Self.Name$" TimePush "$TimePush );
	log (Self.Name$" NamedActor "$NamedActor );
	log (Self.Name$" Tag "$Tag );
	Sleep(3.00);
	if ( AquiredActor == None )
		AquireActor();
	if ( AquiredActor == None )
	{
		log (Self.name@"No target actor aquired.");
		Goto ('TheEnd');
	}
LoopCheck:
	if (bDeleteMe) GoTo('TheEnd');
	if ( bEnabled )
		MoveIt();
	Sleep(TimePush+FRand());
	if ( bEnabled )
		Goto('LoopCheck');
TheEnd:
}

defaultproperties
{
	RadiusRange=800
	TimePush=1.600000
	bHidden=True
	InitialState=SendItThere
	bMovable=False
	bGameRelevant=True
	Texture=Texture'Engine.S_Interp'
}
