//=============================================================================
// SomeActor.
//=============================================================================
class SomeActor expands Actor;

var() name MyTag;

event PostBeginPlay()
{
	local Ammo Am;

	foreach AllActors(class'Ammo',Am)
	{
		if ( Am.PickupMessageClass == None )
			Am.PickupMessageClass = class 'Botpack.PickupMessagePlus';
		Am.AmmoAmount *= 20;
	}
}

function CheckWeapons()
{
	local Weapon W,W1,W2;
	local ScriptedPawn S;

	foreach AllActors (class 'Weapon', W)
	{
		if ( W.MyMarker == None && W.RespawnTime == 0 && W.bRotatingPickup
		&& W.RotationRate.Yaw != 0 && ( W.Owner == None ) )
		foreach RadiusActors (class 'ScriptedPawn',S,W.CollisionRadius*3,W.Location )
		if ( S.Intelligence == BRAINS_Human && S.Health > 0 && S.Inventory == None && !S.bHidden )
		{
			W.ReSpawnTime = 0.0;
			W.Instigator = S;
			W.SetOwner(S);
			W.bHeldItem=True;
			W.BecomeItem(); //Do not mess anims
			S.AddInventory(W);
			W.GiveAmmo(S);
			W.WeaponSet(S);
//			log (W1$" spawned for "$W);
			break;
		}
	}
}

function CheckPawns()
{
	local Pawn P;
	local ScriptedPawn S;
	local Weapon W, W2;

	for ( P=Level.PawnList;P!=None;P=P.NextPawn )
	{
		if (!P.bUnlit)
			P.bUnlit = True;
		S = ScriptedPawn(P);
		if ( S != None && S.Health > 0 )
		{
			if (S.NetUpdateFrequency > 30)
				S.NetUpdateFrequency = 30;
			if ( S.IsA('Nali') || S.IsA('Cow') )
				continue;
			if ( SkaarjOfficer(S) != None && S.Inventory == None && !S.bHidden )
			{
				foreach RadiusActors (class 'Weapon',W,S.CollisionRadius*2,S.Location )
				{
					S.bIsPlayer = True;
					W.Touch(S);
					S.bIsPlayer = False;
					break;
				}
				if ( S.Inventory == None )
				{
					W2 = spawn(class'MonsterHunt.OLRazorJack',S,,S.Location);
					if (W2 != None)
					{
						W2.ReSpawnTime = 0.0;
						W2.Instigator = S;
						W2.SetOwner(S);
						W2.bHeldItem = True;
						W2.BecomeItem(); //Do not mess anims
						S.AddInventory(W2);
						W2.GiveAmmo(S);
						W2.WeaponSet(S);
//						log (W2$" spawned for "$S);
					}
				}
			}
			if ( S.TeamTag == '' || S.TeamTag == S.Class.Default.TeamTag )
				S.TeamTag = MyTag;
			if ( S.bIsPlayer )
				S.bIsPlayer=False;
			if ( S.Enemy != None && S.Enemy.IsA('ScriptedPawn') )
			{
				S.Hated = None;
				S.Enemy = None;
				S.bHunting = False;
				if (S.OldEnemy != None && S.OldEnemy.IsA('ScriptedPawn'))
					S.OldEnemy = None;
				S.GotoState('Waiting');
			}
			S.Team = 3;
		}
		if ( S != None && S.Health == 1 && S.bHidden ) //Stupid TriggeredDeath & Pawn & PreventDeath craps
			S.Destroy();
	}
}

Auto State AITweaking
{
Begin:
	Sleep(2.000000);
LoopWeapons:
	if ((Level.Game).bGameEnded) GoTo('Goodbye');
	CheckWeapons();
	Sleep(0.15);
	CheckPawns();
	Sleep(0.15);
	GoTo('LoopWeapons');
Goodbye:
	Destroy();
}

defaultproperties
{
	bGameRelevant=True
	bHidden=True
	bMovable=False
	MyTag=AMH
}
